##parameters=
# $Id: create_level.py 1495 2007-02-26 12:57:35Z joachim $
"""
process the Application Form
return html renderer + psm
"""
request = context.REQUEST
import DateTime,logging
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
from Products.AdvancedQuery import Eq, Between, Le,In
aq_portal = context.portal_catalog.evalAdvancedQuery

current = DateTime.DateTime()
request = context.REQUEST
session = request.SESSION
response = request.RESPONSE
redirect = response.redirect
logger = logging.getLogger('Student.create_level')
students = context.portal_directories.students
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
member_id = str(member)
lt = context.portal_layouts
wt = context.waeup_tool
student = context.students_catalog(id=context.getStudentId())[0]
cert_id = student.course
current_level = student.level
in_progress =  session.get('in_progress','finished')
if in_progress == 'finished':
    session.set('in_progress','started')
    view = context.in_progress_view(refresh=3,page='%s/study_level_view' % current_level)
    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
    response.setHeader('Content-length','%d' % (len(view)))
    response.setStatus('OK')
    response.write(view)
    response.write('')
elif in_progress == 'started':
    return
context.invokeFactory('StudentStudyLevel',"%s" % current_level)
level = getattr(context,"%s" % current_level)
context.portal_workflow.doActionFor(level,'open')
study_session = context.getSessionString()
level.getContent().edit(mapping={'session': study_session})
context.portal_workflow.doActionFor(level,'close_for_edit')
results = context.results_import(matric_no = student.matric_no)
if results:
    carry_overs = [brain for brain in results if brain.GRADE in ('D','E','F')]
    #carry_overs = [brain for brain in results if int(brain.Score) < 40 ]
    l = []
    for co in carry_overs:
        d = context.getCourseInfo(co.CosCode)
        d['grade'] = co.GRADE
        d['carry_level'] = co.CarryLevel
        cr_id = level.invokeFactory('StudentCourseResult',"%s_co" % co.CosCode)
        course_result = getattr(level,cr_id)
        context.portal_workflow.doActionFor(course_result,'open')
        course_result.getContent().edit(mapping=d)
res = context.portal_catalog(portal_type="Certificate", id = cert_id)
l = []
if res:
    cert = res[0]
    path = cert.getPath()
    query = Eq("path",path) &\
            Eq('portal_type','CertificateCourse') &\
            Eq('SearchableText', "%s" % student.level)
    courses = aq_portal(query)
    for c in courses:
        d = context.getCourseInfo(c.getId)
        cr_id = level.invokeFactory('StudentCourseResult',c.getId)
        course_result = getattr(level,cr_id)
        context.portal_workflow.doActionFor(course_result,'open')
        d['core_or_elective'] = getattr(c.getObject().getContent(),'core_or_elective')
        course_result.getContent().edit(mapping=d)
session.set('in_progress','finished')
return response.redirect("%s" % level.absolute_url())
