## Script (Python) "getStudyCourseInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=student=None
##title=
##
# $Id: getStudyCourseInfo.py 1495 2007-02-26 12:57:35Z joachim $
"""
return Info about the Students StudyCourse
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

request = context.REQUEST

wftool = context.portal_workflow
path_info = request.get('PATH_INFO').split('/')

info = {}
info['is_so'] = context.isSectionOfficer()
info['action'] = "%s" % context.campus.absolute_url()
info['choosen_ids'] = request.get('ids',[])
course  = info['doc'] = context.getContent()
student_id = context.getStudentId()
res = context.students_catalog(id = student_id)
if not res:
    return None
sbrain = res[0]
info['student'] = sbrain
cert_id = sbrain.course
res = context.portal_catalog(portal_type = "Certificate", id = cert_id)
ci = {}
if res:
    info['cert_id'] = cert_id
    brain = res[0]
    ci['study_course'] = brain.getId
    ci['title'] = brain.Title
    pl = brain.getPath().split('/')
    ci['faculty'] = pl[-4]
    ci['department'] = pl[-3]
    info['course_doc'] = ci
else:
    info['course'] = None
items = []
current_level = sbrain.level
levels = context.objectIds()
review_state = wftool.getInfoFor(context,'review_state',None)
if review_state != 'content_addable':
    wftool.doActionFor(context,'close_for_edit')
student_review_state = context.getStudentReviewState()
#may_register = 0 #1 or student_review_state in ('shool_fee_payed',)
may_register = (student_review_state in ('shool_fee_paid',)) and\
               current_level not in levels
levels.sort()
info['create_level'] = None
if may_register:
    info['create_level'] = current_level
for l in levels:
    row = {}
    row['id'] = l
    row['title'] = "Level %s" % l
    row['url'] = "%s/%s" % (context.absolute_url(),l)
    items.append(row)

info['items'] = items
return info
